#include <gnome.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <stdio.h>

#include "thunder-presentation.h"
#include "thunder-box.h"

static GdkPixbuf *
load_image (ThunderBox *box, const char *file, gpointer data)
{
	return gdk_pixbuf_new_from_file (file);
}

int
main (int argc, char *argv[])
{
	FILE *fp;
	char buf[256];
	ThunderPresentation *presentation;
	GtkWidget *box;
	GtkWidget *window;

	gnome_init ("thunder-test", "0.1", argc, argv);

	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_widget_set_usize (window, 800, 600);

	box = thunder_box_new ();
	gtk_signal_connect (GTK_OBJECT (box), "load_image",
			    GTK_SIGNAL_FUNC (load_image),
			    NULL);
	presentation = thunder_presentation_new ();

	fp = fopen ("presentation.ctfdu", "r");
	if (fp == NULL)
		return 1;

	while (fgets (buf, sizeof (buf), fp) != NULL) {
		thunder_presentation_add_xml (presentation, buf);
	}

	thunder_presentation_parse_xml (presentation);

	thunder_box_set_presentation (THUNDER_BOX (box),
				      presentation);

	gtk_object_unref (GTK_OBJECT (presentation));

	gtk_container_add (GTK_CONTAINER (window), box);
	gtk_widget_show_all (window);

	gtk_main ();

	return 0;
}

