

#include <gnome.h>
#include <liboaf/liboaf.h>
#include <bonobo.h>
#include "translator.h"

#include <stdio.h>


#define OBJECT_ID "OAFIID:GNOME_Example_translator:fdbdd6d3-fd72-4709-8ff3-3815a119a160"

int 
main (int argc, char *argv [])
{
	BonoboObjectClient       *server;
	GNOME_Example_Translator  translator;
	CORBA_Environment         ev;
	CORBA_ORB                 orb;
	char line [256];
	char *translated;
	char *ret;

        gnome_init_with_popt_table ("translator-client", "1.0",
				    argc, argv,
				    oaf_popt_options, 0, NULL); 

	orb = oaf_init (argc, argv);

	bonobo_init (orb, CORBA_OBJECT_NIL, CORBA_OBJECT_NIL);

	bonobo_activate ();

	server = bonobo_object_activate (OBJECT_ID, 0);

	CORBA_exception_init (&ev);

	translator = bonobo_object_corba_objref (BONOBO_OBJECT (server));

	puts ("GNOME Example Translator client");
	puts ("Enter input one line at a time.");
	puts ("Enter a dot on a line by itself to quit.");

	printf ("> ");
	for (ret = fgets (line, 256, stdin);
	     ret != NULL && (line[0] != '.' || line[1] != '\n');
	     ret = fgets (line, 256, stdin)) {
	      translated = GNOME_Example_Translator_translate (translator,
							       line, &ev);
	      printf (translated);
	      CORBA_free (translated);
	      printf ("> ");
	}

	CORBA_exception_free (&ev);

	bonobo_object_unref (BONOBO_OBJECT (server));
	
	return 0;
}
