

#include "gnome-example-translator.h"

#include <bonobo.h>
#include <gnome.h>
#include <liboaf/liboaf.h>



#define OBJECT_IID "OAFIID:GNOME_Example_translator:fdbdd6d3-fd72-4709-8ff3-3815a119a160"
#define FACTORY_IID "OAFIID:GNOME_Example_translator-factory:96136a44-3779-49db-b075-3c783ce41b45"


static int object_count = 0;

static void
translator_object_destroyed(GtkObject *obj)
{
	object_count--;
	if (object_count <= 0) {
		gtk_main_quit ();
	}
}

static BonoboObject *
translator_make_object (BonoboGenericFactory *factory, 
			const char *iid, 
			void *closure)
{
	GnomeExampleTranslator *translator;

	if (strcmp (iid, OBJECT_IID)) {
		return NULL;
	}
	
	translator = GNOME_EXAMPLE_TRANSLATOR (gnome_example_translator_new ());

	object_count++;

	gtk_signal_connect (GTK_OBJECT (translator), "destroy", translator_object_destroyed, NULL);

	return BONOBO_OBJECT (translator);
}

int
main (int argc, char *argv[])
{
	BonoboGenericFactory *factory;
	CORBA_ORB orb;
	
	gnome_init_with_popt_table("gnome-example-translator", "0.1", 
				   argc, argv,
				   oaf_popt_options, 0, NULL); 

	orb = oaf_init (argc, argv);
	
	bonobo_init (orb, CORBA_OBJECT_NIL, CORBA_OBJECT_NIL);

        factory = bonobo_generic_factory_new_multi (FACTORY_IID,
						    translator_make_object,
						    NULL);
	do {
		bonobo_main ();
	} while (object_count > 0);
	
	return 0;
}
